extends NPC


export(NodePath) var _visibility_path: NodePath
export(int) var _player_follow_pill_level = 3

var _visibility: Area


func _ready():
	Logger.set_logger_level(Logger.LOG_LEVEL_FINE)
	_visibility = get_node(_visibility_path) as Area
	
	if _visibility:
		_visibility.connect("body_entered", self, "_on_body_entered_visibility")
		_visibility.connect("body_exited", self, "_on_body_exited_visibility")


func _on_body_entered_visibility(body: PhysicsBody):
	Logger.trace("Meldewesen seeing %s" % [body])
	
	if body.is_in_group("Player"):
		Logger.info("Seeing player!")
		
		# If the player didn't take enough pills lately, they're suspicious -> Run towards them!
		if Pills.get_round_level() <= _player_follow_pill_level:
			Logger.info("The player's pill level is too low - following!")
			current_target = body.transform.origin


func _on_body_exited_visibility(body: PhysicsBody):
	if body.is_in_group("Player"):
		Logger.info("Stopped seeing player!")
		current_target = null
